import { ViewBase } from '../../libappbase/viewbase';
import { AppMP } from '../appmp';
import { ButtonCapacitiesContextMenuItem } from '../actionbarpages/abp.data';
import { FormStockingPointCapacities } from '../forms/form.stockingpointcapacities';
import { UIWaitSOP } from '../../libappsop/objectsop';

/**
 * Data > Capacities > Stocking Points view.
 */
export class ViewCapacitiesStockingPoints extends ViewBase implements UIWaitSOP {
  public readonly name = 'Stocking point capacities';
  public readonly viewPath = 'Data > Capacities > Stocking Points';

  public formStockingPointCapacities = new FormStockingPointCapacities();

  /**
   * Switch to Stocking Points Capacities view
   */
  public async switchTo(): Promise<void> {
    const appMP = AppMP.getInstance();

    await appMP.abpData.click();
    await appMP.abpData.btnCapacities.clickDropdownAndSelectMenu(ButtonCapacitiesContextMenuItem.StockingPoint.Name);

    await this.waitUILoaded();
  }

  public async waitUILoaded(): Promise<void> {
    // Wait until form present
    await this.formStockingPointCapacities.waitUntilPresent();
  }
}
